---------------------------
--- Core Addon Creation ---
---------------------------
local tomQuest2 = LibStub("AceAddon-3.0"):NewAddon("tomQuest2", "AceEvent-3.0", "AceTimer-3.0", "AceSerializer-3.0", "AceHook-3.0", "AceBucket-3.0")
tomQuest2.cbh = LibStub("CallbackHandler-1.0"):New(tomQuest2)

-----------------------
--- Library loading ---
-----------------------
local LC = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Core")
local BC = LibStub("LibBabble-Class-3.0"):GetLookupTable()
local LibTourist = LibStub("LibTourist-3.0")

--------------------------------------
--- Copy global functions to local ---
--------------------------------------
local pairs, next, type, GetTime, sort, tinsert = pairs, next, type, GetTime, table.sort, tinsert
local tonumber, format, lower, upper, gsub, strtrim, find, match = tonumber, string.format, string.lower, string.upper, string.gsub, strtrim, string.find, string.match
local GetDailyQuestsCompleted, GetQuestLink, GetQuestGreenRange, QuestDifficultyColor = GetDailyQuestsCompleted, GetQuestLink, GetQuestGreenRange, QuestDifficultyColor
local GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable = GetQuestLogLeaderBoard, GetQuestLogQuestText, GetQuestLogPushable
local GetQuestLogSelection, SelectQuestLogEntry, QuestLog_SetSelection = GetQuestLogSelection, SelectQuestLogEntry, QuestLog_SetSelection
local GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor = GetQuestLogRewardTalents, GetQuestLogRewardMoney, GetQuestLogRewardHonor
local GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo = GetQuestLogRewardSpell, GetQuestLogRewardTitle, GetQuestLogRewardInfo
local GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle = GetQuestLogChoiceInfo, GetQuestLogItemLink, GetQuestLogTitle
local GetNumQuestLogEntries, GetNumQuestLeaderBoards = GetNumQuestLogEntries, GetNumQuestLeaderBoards
local GetNumQuestLogRewards, GetNumQuestLogChoices = GetNumQuestLogRewards, GetNumQuestLogChoices
local GetNumPartyMembers, InCombatLockdown, IsInInstance = GetNumPartyMembers, InCombatLockdown, IsInInstance
local GetQuestLogSpecialItemInfo, UseQuestLogSpecialItem = GetQuestLogSpecialItemInfo, UseQuestLogSpecialItem
local FauxScrollFrame_GetOffset, FauxScrollFrame_SetOffset = FauxScrollFrame_GetOffset, FauxScrollFrame_SetOffset
local QuestLogListScrollFrame, QuestLogListScrollFrameScrollBar = QuestLogListScrollFrame, QuestLogListScrollFrameScrollBar
local CreateFrame, HideUIPanel, ShowUIPanel, SetCVar = CreateFrame, HideUIPanel, ShowUIPanel, SetCVar
local UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat, UnitInRaid = UnitName, UnitClass, UnitLevel, UnitFactionGroup, UnitAffectingCombat, UnitInRaid
local GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro = GetMacroIndexByName, CreateMacro, EditMacro, PickupMacro
local GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell = GetItemQualityColor, GetItemIcon, GetItemInfo, GetItemSpell
local GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink = GetContainerNumSlots, GetInventorySlotInfo, GetContainerItemLink, GetInventoryItemLink

-----------------
--- variables ---
-----------------
local prdb, dbVersion, lastCompatibleDB = nil, 3, 1
local playerName, playerLevel, _, playerClass = UnitName("player"), UnitLevel("player"), UnitClass("player")
local partyZone = LC["PARTYQUESTSZONE"]
local localClass = BC[lower(playerClass):gsub("^%l", upper)]
local numEntries, numItemsStartingQuest, numUsableQuestItems ,numPartyMembers = 0, 0, 0, 0
local party, quests, questsObjectives, questsItems, questsMobs, questsMobsItems, questsIdToUid, questsTitleToUid = {}, {}, {}, {}, {}, {}, {}, {}
local sortedZones, zones, sortedQuestsByZone, questsByZone, sortedQuests = {}, {}, {}, {}, {}
local itemStartingQuest, usableQuestItems, classColors, collapsedHeader, moduleState , items, itemsTimeStamp, rarityColor = {}, {}, {}, {}, {}, {}, {}, {}
local questLogUpdatePending, questLogNeedUpdate, oldInRaid, oldInRaidInstance, abandoning, currentItemMacro, currentUidMacro, firstRun  = nil, nil, nil, nil, nil, nil, nil, true
local objectsPattern = '^' .. QUEST_OBJECTS_FOUND:gsub('(%%%d?$?.)', '(.+)') .. '$'
local monstersPattern = '^' .. QUEST_MONSTERS_KILLED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local factionPattern = '^' .. QUEST_FACTION_NEEDED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local playersPattern = '^'.. QUEST_PLAYERS_KILLED:gsub('(%%%d?$?.)', '(.+)') .. '$'
local DUNGEON, HEROIC, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST  = LFG_TYPE_DUNGEON, DUNGEON_DIFFICULTY2, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST
local reactions = {
	[FACTION_STANDING_LABEL1] = 1, [FACTION_STANDING_LABEL1_FEMALE] = 1,
	[FACTION_STANDING_LABEL2] = 2, [FACTION_STANDING_LABEL2_FEMALE] = 2,
	[FACTION_STANDING_LABEL3] = 3, [FACTION_STANDING_LABEL3_FEMALE] = 3,
	[FACTION_STANDING_LABEL4] = 4, [FACTION_STANDING_LABEL4_FEMALE] = 4,
	[FACTION_STANDING_LABEL5] = 5, [FACTION_STANDING_LABEL5_FEMALE] = 5,
	[FACTION_STANDING_LABEL6] = 6, [FACTION_STANDING_LABEL6_FEMALE] = 6,
	[FACTION_STANDING_LABEL7] = 7, [FACTION_STANDING_LABEL7_FEMALE] = 7,
	[FACTION_STANDING_LABEL8] = 8, [FACTION_STANDING_LABEL8_FEMALE] = 8,
}
local tags = {[ELITE] = "elite", [GROUP] = "group", [PVP] = "pvp", [RAID] = "raid", [DUNGEON] = "dungeon", [HEROIC] = "heroic", [DAILY] = "daily"}
local bagList  = {[0] = true, [1] = true, [2] = true, [3] = true, [4] = true}
local inventorySlot, inventorySlotId = { "HeadSlot", "NeckSlot", "ShoulderSlot", "BackSlot", "ChestSlot", "ShirtSlot", "TabardSlot", "WristSlot", "HandsSlot", "WaistSlot", "LegsSlot", "FeetSlot", "Finger0Slot", "Finger1Slot", "Trinket0Slot", "Trinket1Slot", "MainHandSlot", "SecondaryHandSlot", "RangedSlot", "AmmoSlot"}, {}
local completedString, failedString = format("|cff00ff00%s|r", LC["Finished"]), format("|cffff0000%s|r", LC["Failed"])

-------------------------------------
--- put needed local in tomQuest2 ---
-------------------------------------
tomQuest2.party, tomQuest2.partyZone, tomQuest2.classColors, tomQuest2.sortedZones, tomQuest2.sortedQuestsByZone, tomQuest2.zones, tomQuest2.sortedQuests = party, partyZone, classColors, sortedZones, sortedQuestsByZone, zones, sortedQuests
tomQuest2.quests, tomQuest2.questsObjectives, tomQuest2.questsItems, tomQuest2.questsMobs, tomQuest2.questsMobsItems = quests, questsObjectives, questsItems, questsMobs, questsMobsItems
tomQuest2.questsIdToUid, tomQuest2.questsTitleToUid, tomQuest2.itemStartingQuest, tomQuest2.usableQuestItems = questsIdToUid, questsTitleToUid, itemStartingQuest, usableQuestItems
tomQuest2.playerName, tomQuest2.playerLevel, tomQuest2.playerClass = playerName, playerLevel, playerClass
tomQuest2.numItemsStartingQuest, tomQuest2.numUsableQuestItems, tomQuest2.numPartyMembers = numItemsStartingQuest, numUsableQuestItems, numPartyMembers
tomQuest2.numQuests, tomQuest2.numCompletedQuests, tomQuest2.numCompletedDailyQuests = 0, 0, 0

------------------------------
--- Tooltip Scanning frame ---
------------------------------
local scanTooltipTQ2 = CreateFrame( "GameTooltip", "scanTooltipTQ2", nil, "GameToolTipTemplate")
scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")

-----------------------
--- Table recycling ---
-----------------------
local tablePool = {}
setmetatable(tablePool, {__mode = "kv"})

local function new()
	local t = next(tablePool) or {}
	tablePool[t] = nil
	return t
end

local function del(t)
	if type(t) == "table" then
		for k, v in pairs(t) do
			if type(v) == "table" then
				v = del(v)
			end
			t[k] = nil
		end
		t[true] = true
		t[true] = nil
		setmetatable(t, nil)
		tablePool[t] = true
	end
	return nil
end

--------------------
--- Rarity Color ---
--------------------
for rarity = 0, 6 do
	local r, g, b = GetItemQualityColor(rarity)
	rarityColor[rarity] = format("%02x%02x%02x", r*255, g*255, b*255)
end

--------------------------
--- Status Computation ---
--------------------------
local function computeQuestStatus(uid)
	local totalCompleted, numPlayers, pqStatus = 0, 0, ""
	for partyName, completed in pairs(quests[uid].complete) do
		if partyName ~= playerName and (completed == 1 or completed == -1) then
			numPlayers, totalCompleted = numPlayers + 1, totalCompleted + completed
			if numPlayers > 1 then
				pqStatus = format("%s, |cff%s%s|r: %s", pqStatus, party[partyName].color or "ffffff", partyName:sub(1, 3), completed == 1 and completedString or failedString)
			else
				pqStatus = format("|cff%s%s|r: %s", party[partyName].color or "ffffff", partyName:sub(1, 3), completed == 1 and completedString or failedString)
			end
		end
	end
	if quests[uid].complete[playerName] and (quests[uid].complete[playerName] == 1 or quests[uid].complete[playerName] == -1) then
		numPlayers, totalCompleted = numPlayers + 1, totalCompleted + quests[uid].complete[playerName]
		if quests[uid].complete[playerName] == 1 then
			quests[uid].playerComplete = 1
		else
			quests[uid].playerComplete = 0
		end
		if numPlayers > 1 then
			pqStatus = format("%s, %s", pqStatus, quests[uid].complete[playerName] == 1 and completedString or failedString)
		else
			pqStatus = format("%s", quests[uid].complete[playerName] == 1 and completedString or failedString)
		end
	end
	if totalCompleted == quests[uid].playersOnQuest then
		quests[uid].partyComplete = 1
	else
		quests[uid].partyComplete = 0
	end
	quests[uid].pqStatus = pqStatus
end

local function computeQuestObjectiveStatus(uid, objective)
	local totalGot, numPlayers, qoStatus, qoStatusNC, nNeed = 0, 0, "", "", questsObjectives[uid][objective].nNeed
	local pGot, pNGot, statusString
	for partyName, qoData in pairs(questsObjectives[uid][objective].got) do
		local got, nGot = qoData:match("^(.-)~(%d-)$")
		nGot = tonumber(nGot)
		statusString = nGot == nNeed and LC["d"] or got
		if partyName ~= playerName then
			numPlayers, totalGot = numPlayers + 1, totalGot + nGot
			if numPlayers > 1 then
				qoStatus = format("%s, |cff%s%s|r: |cff%s%s|r", qoStatus, party[partyName].color, partyName:sub(1,3), tomQuest2:getColorFromCompletionHEX(nGot / nNeed), statusString)
				qoStatusNC = format("%s, |cff%s%s|r: %s", qoStatusNC, party[partyName].color, partyName:sub(1,3), statusString)
			else
				qoStatus = format("|cff%s%s|r: |cff%s%s|r", party[partyName].color, partyName:sub(1,3), tomQuest2:getColorFromCompletionHEX(nGot / nNeed), statusString)
				qoStatusNC = format("|cff%s%s|r: %s", party[partyName].color, partyName:sub(1,3), statusString)
			end
		else
			pGot, pNGot = got, nGot
		end
	end
	if pNGot then
		numPlayers, totalGot = numPlayers + 1, totalGot + pNGot
		if pNGot == nNeed then
			questsObjectives[uid][objective].playerComplete = 1
			statusString = LC["d"]
		else
			questsObjectives[uid][objective].playerComplete = 0
			statusString = pGot
		end
		if numPlayers > 1 then
			qoStatus = format("%s, |cff%s%s|r", qoStatus, tomQuest2:getColorFromCompletionHEX(pNGot/nNeed), statusString)
			qoStatusNC = format("%s, %s", qoStatusNC, statusString)
		else
			qoStatus = format("|cff%s%s|r", tomQuest2:getColorFromCompletionHEX(pNGot/nNeed), statusString)
			qoStatusNC = statusString
		end
	end
	if totalGot == numPlayers * nNeed then
		questsObjectives[uid][objective].partyComplete = 1
	else
		questsObjectives[uid][objective].partyComplete = 0
	end
	questsObjectives[uid][objective].qoColor = tomQuest2:getColorFromCompletionHEX(totalGot/ (numPlayers * nNeed))
	questsObjectives[uid][objective].qoStatus = format("%s/|cff%s%s|r", qoStatus, questsObjectives[uid][objective].qoColor, questsObjectives[uid][objective].need)
	questsObjectives[uid][objective].qoStatusNC = format("%s/%s", qoStatusNC, questsObjectives[uid][objective].need)
end

-------------------
--- Class Color ---
-------------------
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
	classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end
local playerColor = classColors[playerClass]

local function updateClassColors()
	for class, color in pairs(CUSTOM_CLASS_COLORS) do
		classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
	end
	if classColors[playerClass] ~= playerColor then
		playerColor = classColors[playerClass]
		for zone in pairs(zones) do
			if zone == localClass then
				zones[zone].color = playerColor
				tomQuest2.cbh:Fire("updateQuestsTooltip")
			end
		end
	end
	if party then
		local colorUpdated = false
		for playerName, pData in pairs(party) do
			if pData.color ~= classColors[pData.class] then
				party[playerName].color = classColors[pData.class]
				colorUpdated = true
			end
		end
		if colorUpdated == true then
			for uid, qData in pairs(quests) do
				computeQuestStatus(uid)
				if qData.numObjectives > 0 then
					for objective in pairs(questsObjectives[uid]) do
						computeQuestObjectiveStatus(uid, objective)
					end
				end
			end
			tomQuest2.cbh:Fire("updateQuestsTooltip")
		end
	end
end

-----------------------
--- Default profile ---
-----------------------
local defaults = {
	profile = {
		modules = {
			dailyTooltip = true,
			notifications = true,
			informations = true,
			questsTooltip = true,
			questsTracker = true,
			soundNotifications = true,
			syncParty = true,
			tagQuestGivers = true,
			tagQuestLog = true,
			tooltips = true,
			announce = false,
			achievementTracker = true,
			questsInfo = true,
		},
		raidModules = {
			enabled = true,
			dailyTooltip = "inRaidInstance",
			notifications = "inRaidInstance",
			informations = "enabled",
			questsTooltip = "enabled",
			questsTracker = "inRaidInstance",
			soundNotifications = "enabled",
			syncParty = "inRaidInstance",
			tagQuestGivers = "enabled",
			tagQuestLog = "enabled",
			tooltips = "inRaidInstance",
			announce = "inRaidInstance",
			achievementTracker = "enabled",
			questsInfo = "enabled",
		},
		quests = {
			zoneSorting = "levelA", zoneWithoutLvlPos = 0, questsSorting = "weightedA",
			hideDefaultBlizTracker = true,
			maxLevelDiff = 3, eliteAddLevel = 3, groupAddLevel = 1, dungeonAddLevel = 2, heroicAddLevel = 3,
			elite = '+', group = 'g', pvp = 'p', raid = 'r', dungeon = 'd', heroic = 'd+', daily = "\226\128\162",
			completedColor = "00ff00", failedColor = "ff0000",
			customColorMode = true,
			rj0 = 1, gj0 = 0, bj0 = 0,
			ri1 = 0, rj1 = 1, gi1 = 2, gj1 = 0, bi1 = 0, bj1 = 0,
			ri2 = -2, rj2 = 2, gi2 = 0, gj2 = 1, bi2 = 0, bj2 = 0,
			rj3 = 0, gj3 = 1, bj3 = 0,
		},
	},
}

----------------------
--- Initialization ---
----------------------
function tomQuest2:Print(text)
	if text then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99tomQuest2|r: "..text)
	end
end

tomQuest2:SetDefaultModuleState(false)
function tomQuest2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("tomQuest2DB", defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	prdb = self.db.profile
	tomQuest2:setQuestStatusString()
	if prdb.modules["questsTracker"] then
		SetCVar("autoQuestWatch", 0)
		SetCVar("autoQuestProgress", 0)
	else
		SetCVar("autoQuestWatch", 1)
		SetCVar("autoQuestProgress", 1)
	end
	SetCVar("advancedWatchFrame", 1)
	if prdb.version and prdb.version < lastCompatibleDB then
		self.db:ResetDB()
		tomQuest2:Refresh()
	elseif prdb.version == 2 then
		tomQuest2.cbh:Fire("updateDBtoV3")
	end
	prdb.version = dbVersion
	self:SetupOptions()
	for k, v in pairs(inventorySlot) do
		local slotId = GetInventorySlotInfo(v)
		inventorySlotId[slotId] = true
	end
	self:RegisterEvent("QUEST_LOG_UPDATE")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "inCombat")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "inCombat")
	if prdb.raidModules.enabled then
		self:RegisterEvent("RAID_ROSTER_UPDATE", "checkRaid")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "checkRaid")
	end
end

function tomQuest2:OnEnable()
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(updateClassColors)
	end
	self:SecureHook("AbandonQuest")
	self:SecureHook("WatchFrame_Update")
	if prdb.quests.hideDefaultBlizTracker then
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WatchFrame:SetUserPlaced(true)
		WatchFrame:SetPoint("TOP", "UIParent", "TOP")
	end
	WATCHFRAME_MAXQUESTS = 100
	WATCHFRAME_MAXACHIEVEMENTS = 100
	MAX_WATCHABLE_QUESTS = 100
end

function tomQuest2:Refresh()
	prdb = self.db.profile
	prdb.version = dbVersion
	for k, v in self:IterateModules() do
		if self:getModuleEnabled(k) and not v:IsEnabled() then
			self:EnableModule(k)
		elseif not self:getModuleEnabled(k) and v:IsEnabled() then
			self:DisableModule(k)
		end
		if v.Refresh and type(v.Refresh) == "function" then
			v:Refresh()
		end
	end
	tomQuest2:computeQuestTag()
	tomQuest2:computeQuestsObjectivesStatus()
end

function tomQuest2:getModuleEnabled(module)
	return prdb.modules[module]
end


function tomQuest2:setModuleEnabled(module, value)
	local old = prdb.modules[module]
	prdb.modules[module] = value
	moduleState[module] = value
	if old ~= value then
		if value then
			self:EnableModule(module)
			if module == "questsTracker" then
				SetCVar("autoQuestWatch", 0)
				SetCVar("autoQuestProgress", 0)
			end
		else
			self:DisableModule(module)
			if module == "questsTracker" then
				SetCVar("autoQuestWatch", 1)
				SetCVar("autoQuestProgress", 1)
			end
		end
	end
end

function tomQuest2:updateRaidMode(value)
	if value then
		self:RegisterEvent("RAID_ROSTER_UPDATE", "checkRaid")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "checkRaid")
		tomQuest2:checkRaid()
	else
		self:UnregisterEvent("RAID_ROSTER_UPDATE")
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		for k in tomQuest2:IterateModules() do
			if prdb.modules[k] ~= moduleState[k] then
				tomQuest2:setModuleEnabled(k, prdb.modules[k])
			end
		end 
	end
end

function tomQuest2:checkRaid()
	local inRaid = UnitInRaid("player")
	local _, instanceType = IsInInstance()
	local inRaidInstance = instanceType == "raid" and true or nil
	if (inRaid and not oldInRaid) or (not inRaid and oldInRaid) then
		for k in tomQuest2:IterateModules() do
			if prdb.raidModules[k] == "inRaid" then
				if inRaid and moduleState[k] then
					moduleState[k] = false
					tomQuest2:DisableModule(k)
				elseif not inRaid and not moduleState[k] and prdb.modules[k] then
					tomQuest2:EnableModule(k)
				end
			end
		end
	end
	if (inRaidInstance and not oldInRaidInstance) or (not inRaidInstance and oldInRaidInstance) then
		for k in tomQuest2:IterateModules() do
			if prdb.raidModules[k] == "inRaidInstance" then
				if inRaidInstance and moduleState[k] then
					tomQuest2:DisableModule(k)
				elseif not inRaidInstance and not moduleState[k] and prdb.modules[k] then
					tomQuest2:EnableModule(k)
				end
			end
		end
	end
	oldInRaid = inRaid
	oldInRaidInstance = inRaidInstance
end

function tomQuest2:setQuestStatusString()
	completedString = format("|cff%s%s|r", prdb.quests.completedColor, LC["Finished"])
	failedString = format("|cff%s%s|r", prdb.quests.failedColor, LC["Failed"])
end

------------------------------------
--- Bliz Quest Tracker show hide ---
------------------------------------
function tomQuest2:WatchFrame_Update()
	if prdb.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
	else
		WatchFrame:Show()
		WatchFrameTitleButton:Show()
		WatchFrameLines:Show()
	end
end

function tomQuest2:hideShowDefaultBlizTracker()
	if prdb.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		WatchFrameTitleButton:Hide()
		WatchFrameLines:Hide()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 0, 0, 0, 0
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 0, 0, 0
		WATCHFRAMELINES_FONTHEIGHT, WATCHFRAMELINES_FONTSPACING = 0, 0
		WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
	else
		WatchFrame:Show()
		WatchFrameTitleButton:Show()
		WatchFrameLines:Show()
		WATCHFRAME_LINEHEIGHT, WATCHFRAME_LINEHEIGHT_WITHICON , WATCHFRAME_QUESTTIMER_HEIGHT, WATCHFRAME_QUEST_WITH_ITEM_HEIGHT = 16, 26, 37, 39
		WATCHFRAME_INITIAL_OFFSET, WATCHFRAME_TYPE_OFFSET, WATCHFRAME_QUEST_OFFSET, WATCHFRAMELINES_YOFFSET = 0, 5, 10, 42
		WATCHFRAMELINES_FONTHEIGHT = WatchFrameLines:GetHeight()
		WATCHFRAMELINES_FONTSPACING = (WATCHFRAME_LINEHEIGHT - WATCHFRAMELINES_FONTHEIGHT) / 2
	end
end

-------------------------
--- Hook AbandonQuest ---
-------------------------
function tomQuest2:AbandonQuest()
	abandoning = true
end

-----------------------
--- Tools Functions ---
-----------------------
local function getDifficultyColor(levelDiff)
	local color
	if ( levelDiff >= 5 ) then
		color = QuestDifficultyColor["impossible"]
	elseif ( levelDiff >= 3 ) then
		color = QuestDifficultyColor["verydifficult"]
	elseif ( levelDiff >= -2 ) then
		color = QuestDifficultyColor["difficult"]
	elseif ( -levelDiff <= GetQuestGreenRange() ) then
		color = QuestDifficultyColor["standard"]
	else
		color = QuestDifficultyColor["trivial"]
	end
	return color
end

local function normalizeColorComponent(component)
	if component > 1 then return 1 elseif component < 0 then return 0 else return component end
end

function tomQuest2:getColorFromCompletionRGB(percent)
	if percent <= 0 then
		return normalizeColorComponent(prdb.quests.rj0), normalizeColorComponent(prdb.quests.gj0), normalizeColorComponent(prdb.quests.bj0)
	elseif percent >= 1 then
		return normalizeColorComponent(prdb.quests.rj3), normalizeColorComponent(prdb.quests.gj3), normalizeColorComponent(prdb.quests.bj3)
	elseif percent <= 0.5 then
		return normalizeColorComponent(prdb.quests.ri1*percent + prdb.quests.rj1), normalizeColorComponent(prdb.quests.gi1*percent + prdb.quests.gj1), normalizeColorComponent(prdb.quests.bi1*percent + prdb.quests.bj1)
	else
		return normalizeColorComponent(prdb.quests.ri2*percent + prdb.quests.rj2), normalizeColorComponent(prdb.quests.gi2*percent + prdb.quests.gj2), normalizeColorComponent(prdb.quests.bi2*percent + prdb.quests.bj2)
	end
end

function tomQuest2:getColorFromCompletionHEX(percent)
	if percent <= 0 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.rj0), 255*normalizeColorComponent(prdb.quests.gj0), 255*normalizeColorComponent(prdb.quests.bj0))
	elseif percent >= 1 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.rj3), 255*normalizeColorComponent(prdb.quests.gj3), 255*normalizeColorComponent(prdb.quests.bj3))
	elseif percent <= 0.5 then
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.ri1*percent + prdb.quests.rj1), 255*normalizeColorComponent(prdb.quests.gi1*percent + prdb.quests.gj1), 255*normalizeColorComponent(prdb.quests.bi1*percent + prdb.quests.bj1))
	else
		return format("%02x%02x%02x", 255*normalizeColorComponent(prdb.quests.ri2*percent + prdb.quests.rj2), 255*normalizeColorComponent(prdb.quests.gi2*percent + prdb.quests.gj2), 255*normalizeColorComponent(prdb.quests.bi2*percent + prdb.quests.bj2))
	end
end

---------------------
--- Zones Sorting ---
---------------------
local function getLevel(level)
	if level == "" then
		return prdb.quests.zoneWithoutLvlPos
	else
		return level
	end
end

local zSort = {
	nameD = function(a, b)
		return a > b
	end,
	nameA = function(a, b)
		return a < b
	end,
	levelD = function(a, b)
		local aMin, aMax = getLevel(zones[a].minLevel), getLevel(zones[a].maxLevel)
		local bMin, bMax = getLevel(zones[b].minLevel), getLevel(zones[b].maxLevel)
		if aMax == bMax then
			if aMin == bMin then
				return a > b
			else
				return aMin > bMin
			end
		else
			return aMax > bMax
		end
	end,
	levelA = function(a, b)
		local aMin, aMax = getLevel(zones[a].minLevel), getLevel(zones[a].maxLevel)
		local bMin, bMax = getLevel(zones[b].minLevel), getLevel(zones[b].maxLevel)
		if aMax == bMax then
			if aMin == bMin then
				return a < b
			else
				return aMin < bMin
			end
		else
			return aMax < bMax
		end
	end
}


local function zonesSort()
	for i in pairs(sortedZones) do
		sortedZones[i] = nil
	end
	for zone in pairs(zones) do
		tinsert(sortedZones, zone)
	end
	sort(sortedZones, zSort[prdb.quests.zoneSorting])
end

----------------------
--- Quests Sorting ---
----------------------
local qSort = {
	weightedA = function(a, b)
		local aWL, bWL = quests[a].weightedLevel, quests[b].weightedLevel
		if aWL == bWL then
			return quests[a].title < quests[b].title
		else
			return aWL < bWL
		end
	end,
	weightedD = function(a, b)
		local aWL, bWL = quests[a].weightedLevel, quests[b].weightedLevel
		if aWL == bWL then
			return quests[a].title > quests[b].title
		else
			return aWL > bWL
		end
	end,
	levelA = function(a, b)
		local aL, bL = quests[a].level, quests[b].level
		if aL == bL then
			return quests[a].title < quests[b].title
		else
			return aL < bL
		end
	end,
	levelD = function(a, b)
		local aL, bL = quests[a].level, quests[b].level
		if aL == bL then
			return quests[a].title > quests[b].title
		else
			return aL > bL
		end
	end,
	nameA = function(a, b)
		return quests[a].title > quests[b].title
	end,
	nameD = function(a, b)
		return quests[a].title < quests[b].title
	end,
}

local function questsSort()
	for zone in pairs(sortedQuestsByZone) do
		for i in pairs(sortedQuestsByZone[zone]) do
			sortedQuestsByZone[zone][i] = nil
		end
		sortedQuestsByZone[zone] = nil
	end
	for i in pairs(sortedQuests) do
		sortedQuests[i] = nil
	end
	for zone in pairs(zones) do
		sortedQuestsByZone[zone] = new()
		for uid in pairs(questsByZone[zone]) do
			tinsert(sortedQuestsByZone[zone], uid)
			tinsert(sortedQuests, uid)
		end
		sort(sortedQuestsByZone[zone], qSort[prdb.quests.questsSorting])
	end
	sort(sortedQuests, qSort[prdb.quests.questsSorting])
end

----------------
--- Sort all ---
----------------
function tomQuest2:allSort()
	zonesSort()
	questsSort()
end

------------------------
--- Quests Functions ---
------------------------
function tomQuest2:computeQuestsObjectivesStatus()
	for uid, qoData in pairs (questsObjectives) do
		for objective in pairs (qoData) do
			computeQuestObjectiveStatus(uid, objective)
		end
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
	tomQuest2.cbh:Fire("questLogUpdated", true, true)
end


function tomQuest2:computeQuestsStatus()
	for uid in pairs (quests) do
		computeQuestStatus(uid)
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
	tomQuest2.cbh:Fire("questLogUpdated", true, true)
end


function tomQuest2:addZone(zone)
	questsByZone[zone] = new()
	zones[zone] = new()
	zones[zone].numQuests = 0
	if zone == partyZone then
		zones[zone].minLevel, zones[zone].maxLevel, zones[zone].level = "", "", ""
		zones[zone].color = "ffffff"
		zones[zone].zone = true
	elseif zone == localClass then
		zones[zone].minLevel, zones[zone].maxLevel, zones[zone].level = "", "", ""
		zones[zone].color = playerColor
	else
		zones[zone].minLevel, zones[zone].maxLevel = LibTourist:GetLevel(zone)
		if zones[zone].maxLevel == 0 then
			zones[zone].level = ""
			zones[zone].color = "ffffff"
		else
			zones[zone].level = format("(%s-%s)", zones[zone].minLevel, zones[zone].maxLevel)
			local r, g, b = LibTourist:GetLevelColor(zone)
			zones[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
			zones[zone].zone = true
		end
	end
	zonesSort()
end

local function addQuestDetails(uid)
	if quests[uid].extras then
		return
	else
		local status = true
		local id = quests[uid].id
		SelectQuestLogEntry(id)
		local specialItemLink, specialItemIcon = GetQuestLogSpecialItemInfo(id)
		quests[uid].specialItemLink, quests[uid].specialItemIcon = specialItemLink, specialItemIcon
		if specialItemLink then
			if items[specialItemLink] and items[specialItemLink] ~= uid then
				if items[specialItemLink] == 0 then
					numItemsStartingQuest = numItemsStartingQuest - 1
					itemStartingQuest[specialItemLink] = del(itemStartingQuest[specialItemLink])
				elseif items[specialItemLink] == -1 then
					numUsableQuestItems = numUsableQuestItems - 1
					usableQuestItems[specialItemLink] = del(usableQuestItems[specialItemLink])
				end
			end
			items[specialItemLink] = uid
		end
		quests[uid].sharable = GetQuestLogPushable()
		if not quests[uid].extraSync then
			quests[uid].description, quests[uid].objective = GetQuestLogQuestText()
			quests[uid].money = GetQuestLogRewardMoney() or 0
			quests[uid].honor = GetQuestLogRewardHonor() or 0
			quests[uid].talent = GetQuestLogRewardTalents() or 0
			quests[uid].titleReward = GetQuestLogRewardTitle() or ""
			local numRewards = GetNumQuestLogRewards() or 0
			local numChoices = GetNumQuestLogChoices() or 0
			quests[uid].numRewards, quests[uid].numChoices = numRewards, numChoices
			local rewardSpellTexture, rewardSpellName = GetQuestLogRewardSpell()
			quests[uid].rewardSpellTexture = rewardSpellTexture or ""
			quests[uid].rewardSpellName = rewardSpellName or ""
			if numRewards > 0 then
				quests[uid].itemRewards = new()
				for i = 1, numRewards do
					quests[uid].itemRewards[i] = new()
					quests[uid].itemRewards[i].name, quests[uid].itemRewards[i].texture, quests[uid].itemRewards[i].numItems, quests[uid].itemRewards[i].quality, quests[uid].itemRewards[i].isUsable = GetQuestLogRewardInfo(i)
					quests[uid].itemRewards[i].link = GetQuestLogItemLink('reward', i)
					if not quests[uid].itemRewards[i].link then
						status = nil
					elseif not quests[uid].itemRewards[i].texture then
						quests[uid].itemRewards[i].texture = GetItemIcon(quests[uid].itemRewards[i].link)
					end
				end
			end
			if numChoices > 0 then
				quests[uid].itemChoices = new()
				for i = 1, numChoices do
					quests[uid].itemChoices[i] = new()
					quests[uid].itemChoices[i].name, quests[uid].itemChoices[i].texture, quests[uid].itemChoices[i].numItems, quests[uid].itemChoices[i].quality, quests[uid].itemChoices[i].isUsable = GetQuestLogChoiceInfo(i)
					quests[uid].itemChoices[i].link = GetQuestLogItemLink('choice', i)
					if not quests[uid].itemChoices[i].link then
						status = nil
					elseif not quests[uid].itemChoices[i].texture then
						quests[uid].itemChoices[i].texture = GetItemIcon(quests[uid].itemChoices[i].link)
					end
				end
			end
		end

		if (quests[uid].description or quests[uid].objective) then
			for itemLink, itemData in pairs(items) do
				if itemData and (itemData == 0 or itemData == -1) then
					local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(itemLink)
					if (quests[uid].objective and quests[uid].objective:find(itemName, 1, true)) or (quests[uid].description and quests[uid].description:find(itemName, 1, true)) then
						if itemData == 0 then
							numItemsStartingQuest = numItemsStartingQuest - 1
							itemStartingQuest[itemLink] = del(itemStartingQuest[itemLink])
						elseif itemData == -1 then
							numUsableQuestItems = numUsableQuestItems - 1
							usableQuestItems[itemLink] = del(usableQuestItems[itemLink])
						end
						items[itemLink] = uid
						quests[uid].specialItemLink, quests[uid].specialItemIcon = itemLink, itemTexture
					end
				end
			end
		else
			status = nil
		end

		if status then
			quests[uid].extras = true
		else
			quests[uid].numRewards = 0
			quests[uid].numChoices = 0
			tomQuest2:ScheduleTimer(addQuestDetails, 0.1, uid)
		end
	end
end

function tomQuest2:addQuest(sender, first, uid, title, level, tag, group, daily, numObjectives, completed, zone, id)
	if not quests[uid] then
		quests[uid] = new()
		quests[uid].playersOnQuest = 0
		quests[uid].playerComplete = 0
		quests[uid].partyComplete = 0
		quests[uid].title = title
		quests[uid].level = level
		quests[uid].zone = zone
		quests[uid].numObjectives = numObjectives
		quests[uid].complete = new()
		local qc = getDifficultyColor(level - playerLevel)
		quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
		quests[uid].shortTag = tag
		quests[uid].group = group
		quests[uid].daily = daily
		if level > 0 or tag ~= "" or group > 0 or daily == 1 then
			quests[uid].tag = format("[%s%s%s%s]", level or "", tag ~= "" and prdb.quests[tags[tag]] or "", group > 0 and group or "", daily == 1 and (tag ~= DAILY and prdb.quests[tags[DAILY]] or "") or "")
		else
			quests[uid].tag = ""
		end
		if tag == ELITE and (prdb.quests.eliteAddLevel or 0) > 0 then
			quests[uid].weightedLevel = (level or 0) + prdb.quests.eliteAddLevel
		elseif tag == GROUP and (prdb.quests.groupAddLevel or 0) > 0 then
			quests[uid].weightedLevel = (level or 0) + (prdb.quests.groupAddLevel * (quests[uid].group - (numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif tag == HEROIC and (prdb.quests.heroicAddLevel or 0) > 0 then
			quests[uid].weightedLevel = (level or 0) + (prdb.quests.heroicAddLevel * (5 - (numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif tag == DUNGEON and (prdb.quests.dungeonAddLevel or 0) > 0 then
			quests[uid].weightedLevel = (level or 0) + (prdb.quests.dungeonAddLevel * (5 - (numPartyMembers or (GetNumPartyMembers() or 0))))
		else
			quests[uid].weightedLevel = (level or 0)
		end
		if numObjectives > 0 then
			questsObjectives[uid] = new()
		end
		if sender ~= playerName then
			questsByZone[partyZone][uid] = true
			zones[partyZone].numQuests = zones[partyZone].numQuests + 1
		else
			questsByZone[zone][uid] = true
			zones[zone].numQuests = zones[zone].numQuests + 1
			if zone == localClass then
				quests[uid].class = true
			end
		end
	end
	quests[uid].complete[sender] = completed
	quests[uid].playersOnQuest = quests[uid].playersOnQuest + 1
	if sender == playerName then
		if quests[uid].playersOnQuest > 1 then
			questsByZone[zone][uid] = true
			zones[zone].numQuests = zones[zone].numQuests + 1
			questsByZone[partyZone][uid] = nil
			zones[partyZone].numQuests = zones[partyZone].numQuests - 1
			if zones[partyZone].numQuests == 0 then
				questsByZone[partyZone] = del(questsByZone[partyZone])
				zones[partyZone] = del(zones[partyZone])
			end
			zonesSort()
		end
		tomQuest2.cbh:Fire("addPlayerQuest", first, "q", uid, title, level, tag, group, daily, numObjectives, completed, zone)
	else
		tomQuest2.cbh:Fire("addPartyQuest", nil, nil, uid)
	end
	computeQuestStatus(uid)
	questsSort()
end

function tomQuest2:questComplete(sender, first, uid)
	quests[uid].complete[sender] = 1
	computeQuestStatus(uid)
	if sender == playerName then
		tomQuest2.cbh:Fire("playerQuestComplete", first, "c", uid)
	else
		tomQuest2.cbh:Fire("partyQuestComplete", nil, nil, uid, sender)
	end
end

function tomQuest2:questUnComplete(sender, first, uid)
	quests[uid].complete[sender] = 0
	computeQuestStatus(uid)
	if sender == playerName then
		tomQuest2.cbh:Fire("playerQuestUnComplete", first, "c", uid)
	else
		tomQuest2.cbh:Fire("partyQuestUnComplete", nil, nil, uid, sender)
	end
end

function tomQuest2:questFailed(sender, first, uid)
	quests[uid].complete[sender] = -1
	computeQuestStatus(uid)
	if sender == playerName then
		tomQuest2.cbh:Fire("playerQuestFailed", first, "f", uid)
	else
		tomQuest2.cbh:Fire("partyQuestFailed", nil, nil, uid, sender)
	end
end

function tomQuest2:addQuestObjective(sender, first, uid, objective, desc, qType, got, need, nGot, nNeed)
	if not questsObjectives[uid][objective] then
		questsObjectives[uid][objective] = new()
		questsObjectives[uid][objective].desc = desc
		questsObjectives[uid][objective].qType = qType
		questsObjectives[uid][objective].nNeed = nNeed
		questsObjectives[uid][objective].need = need
		questsObjectives[uid][objective].got = new()
		if qType == "object" then
			if not questsItems[desc] then
				questsItems[desc] = new()
				questsItems[desc].numQuests = 0
				questsItems[desc].quests = new()
			end
			if not questsItems[desc].quests[uid] then
				questsItems[desc].numQuests = questsItems[desc].numQuests + 1
				questsItems[desc].quests[uid] = objective
			end
			if MobMapDotParentFrame then
				if not MobMap_GetDropItemNameList then
					MobMap_LoadDatabase(7)
				end
				if MobMap_GetDropItemNameList then
					local mobMapDropList = MobMap_GetDropItemNameList(desc)
					if mobMapDropList then
						local mobMapDropChance = MobMap_GetDropChances(mobMapDropList[1])
						for k, v in pairs(mobMapDropChance) do
							if v.mobid and v.mobid ~= 0 then
								local mobName = MobMap_GetMobName(v.mobid)
								if not questsItems[desc].mobDrop then
									questsItems[desc].mobDrop = new()
								end
								questsItems[desc].mobDrop[mobName] = true
								if not questsMobsItems[mobName] then
									questsMobsItems[mobName] = new()
									questsMobsItems[mobName].items = new()
									questsMobsItems[mobName].numItems = 0
									local zoneId = MobMap_GetMobZone(v.mobid)
									questsMobsItems[mobName].mobLoc = new()
									local zoneName = "???"
									if zoneId.id ~= nil then
										zoneName = MobMap_GetZoneName(zoneId.id)
									end
									questsMobsItems[mobName].mobLoc[zoneName] = true
								end
								if not questsMobsItems[mobName].items[desc] then
									questsMobsItems[mobName].numItems = questsMobsItems[mobName].numItems + 1
									questsMobsItems[mobName].items[desc] = new()
									questsMobsItems[mobName].items[desc].numQuests = 0
									questsMobsItems[mobName].items[desc].dropRate = v.chance
									questsMobsItems[mobName].items[desc].quests = new()
								end
								if not questsMobsItems[mobName].items[desc].quests[uid] then
									questsMobsItems[mobName].items[desc].numQuests = questsMobsItems[mobName].items[desc].numQuests + 1
									questsMobsItems[mobName].items[desc].quests[uid] = objective
								end
							end
						end
					end
				end
			end
		elseif qType == "monster" then
			if not questsMobs[desc] then
				questsMobs[desc] = new()
				questsMobs[desc].numQuests = 0
				questsMobs[desc].quests = new()
			end
			if not questsMobs[desc].quests[uid] then
				questsMobs[desc].numQuests = questsMobs[desc].numQuests + 1
				questsMobs[desc].quests[uid] = objective
			end
		end
	end
	questsObjectives[uid][objective].got[sender] = format("%s~%d", got, nGot)
	computeQuestObjectiveStatus(uid, objective)
	if sender == playerName then
		tomQuest2.cbh:Fire("addPlayerQuestObjective", first, "o", uid, objective, desc, qType, got, need, nGot, nNeed)
	else
		tomQuest2.cbh:Fire("addPartyQuestObjective", nil, nil, uid, objective)
	end
end

function tomQuest2:questObjectiveProgress(sender, first, uid, objective, got, nGot)
	questsObjectives[uid][objective].got[sender] = format("%s~%d", got, nGot)
	computeQuestObjectiveStatus(uid, objective)
	if sender == playerName then
		tomQuest2.cbh:Fire("playerQuestObjectiveProgress", first, "p", uid, objective, got, nGot)
	else
		tomQuest2.cbh:Fire("partyQuestObjectiveProgress", nil, nil, uid, objective, got, nGot, sender)
	end
end

function tomQuest2:questLost(sender, first, uid, abandoning, message)
	local title = quests[uid].title
	local updateBag = nil
	if sender == playerName and quests[uid].specialItemLink then
		items[quests[uid].specialItemLink] = nil
		updateBag = true
	end
	quests[uid].playersOnQuest = quests[uid].playersOnQuest - 1
	if quests[uid].numObjectives > 0 then
		for objective, qoData in pairs(questsObjectives[uid]) do
			questsObjectives[uid][objective].got[sender] = nil
			if quests[uid].playersOnQuest == 0 then
				if qoData.qType == "object" then
					if questsItems[qoData.desc] then
						questsItems[qoData.desc].quests[uid] = nil
						questsItems[qoData.desc].numQuests = questsItems[qoData.desc].numQuests - 1
						if questsItems[qoData.desc].mobDrop then
							for mobName in pairs(questsItems[qoData.desc].mobDrop) do
								questsMobsItems[mobName].items[qoData.desc][uid] = nil
							end
						end
						if questsItems[qoData.desc].numQuests == 0 then
							if questsItems[qoData.desc].mobDrop then
								for mobName in pairs(questsItems[qoData.desc].mobDrop) do
									questsMobsItems[mobName].items[qoData.desc] = del(questsMobsItems[mobName].items[qoData.desc])
									questsMobsItems[mobName].numItems = questsMobsItems[mobName].numItems - 1
									if questsMobsItems[mobName].numItems == 0 then
										questsMobsItems[mobName] = del(questsMobsItems[mobName])
									end
								end
							end
							questsItems[qoData.desc] = del(questsItems[qoData.desc])
						end
					end
				elseif qoData.qType == "monster" then
					questsMobs[qoData.desc].quests[uid] = nil
					questsMobs[qoData.desc].numQuests = questsMobs[qoData.desc].numQuests - 1
					if questsMobs[qoData.desc].numQuests == 0 then
						questsMobs[qoData.desc] = del(questsMobs[qoData.desc])
					end
				end
				questsObjectives[uid][objective] = del(questsObjectives[uid][objective])
			else
				computeQuestObjectiveStatus(uid, objective)
			end
		end
	end
	quests[uid].complete[sender] = nil
	if quests[uid].playersOnQuest == 0 then
		local zone
		if sender == playerName then
			if currentUidMacro == uid then
				tomQuest2:generateSpecialItemMacro()
			end
			questsTitleToUid[title] = nil
			questsIdToUid[quests[uid].id] = nil
			zone = quests[uid].zone
		else
			zone = partyZone
		end
		zones[zone].numQuests = zones[zone].numQuests - 1
		questsByZone[zone][uid] = nil
		if zones[zone].numQuests == 0 then
			questsByZone[zone] = del(questsByZone[zone])
			zones[zone] = del(zones[zone])
		end
		if quests[uid].numObjectives > 0 then
			questsObjectives[uid] = del(questsObjectives[uid])
		end
		quests[uid] = del(quests[uid])
	else
		if sender == playerName then
			if currentUidMacro == uid then
				tomQuest2:generateSpecialItemMacro()
			end
			questsTitleToUid[title] = nil
			questsIdToUid[quests[uid].id] = nil
			quests[uid].id = nil
			local zone = quests[uid].zone
			zones[zone].numQuests = zones[zone].numQuests - 1
			questsByZone[zone][uid] = nil
			if zones[zone].numQuests == 0 then
				questsByZone[zone] = del(questsByZone[zone])
				zones[zone] = del(zones[zone])
			end
			if not questsByZone[partyZone] then
				tomQuest2:addZone(partyZone)
			end
			zones[partyZone].numQuests = zones[partyZone].numQuests + 1
			questsByZone[partyZone][uid] = true
		end
		computeQuestStatus(uid)
	end
	if updateBag then
		tomQuest2:updateBag()
	end
	zonesSort()
	questsSort()
	if sender == playerName then
		tomQuest2.cbh:Fire("playerQuestLost", first, "l", uid, abandoning)
	elseif message == 1 then
		tomQuest2.cbh:Fire("partyQuestLost", nil, nil, uid, abandoning, title, sender)
	end
end

function tomQuest2:computeQuestLevel()
	for uid, questData in pairs(quests) do
		if questData.shortTag == ELITE and prdb.quests.eliteAddLevel > 0 then
			quests[uid].weightedLevel = (questData.level or 0) + prdb.quests.eliteAddLevel
		elseif questData.shortTag == GROUP and prdb.quests.groupAddLevel > 0 then
			quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.groupAddLevel * (quests[uid].group - (numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif questData.shortTag == HEROIC and prdb.quests.heroicAddLevel > 0 then
			quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.heroicAddLevel * (5 - (numPartyMembers or (GetNumPartyMembers() or 0))))
		elseif questData.shortTag == DUNGEON and prdb.quests.dungeonAddLevel > 0 then
			quests[uid].weightedLevel = (questData.level or 0) + (prdb.quests.dungeonAddLevel * (5 - (numPartyMembers or (GetNumPartyMembers() or 0))))
		else
			quests[uid].weightedLevel = (questData.level or 0)
		end
	end
	questsSort()
	tomQuest2.cbh:Fire("updateQuestsTracker")
end

function tomQuest2:computeQuestTag()
	for uid, questData in pairs(quests) do
		if questData.level > 0 or questData.shortTag ~= "" or questData.group > 0 or questData.daily ~= "" then
			quests[uid].tag = format("[%s%s%s%s]", questData.level or "", questData.shortTag ~= "" and prdb.quests[tags[questData.shortTag]] or "", questData.group > 0 and questData.group or "", questData.daily and (questData.shortTag ~= DAILY and prdb.quests[tags[DAILY]]))
		else
			quests[uid].tag = ""
		end
	end
	tomQuest2.cbh:Fire("updateQuestsTracker")
end

------------------------
--- QUEST_LOG_UPDATE ---
------------------------
function tomQuest2:QUEST_LOG_UPDATE(event)
	if (not event or event ~= "FORCED") and questLogUpdatePending then return end
	questLogUpdatePending = false
	questLogNeedUpdate = false
	for i in pairs(questsIdToUid) do questsIdToUid[i] = nil end
	for i in pairs(questsTitleToUid) do questsTitleToUid[i] = nil end
	local selectionId = GetQuestLogSelection()
	local timeStamp = GetTime()
	tomQuest2.numCompletedQuests = 0
	numEntries, tomQuest2.numQuests = GetNumQuestLogEntries()
	tomQuest2.numCompletedDailyQuests = GetDailyQuestsCompleted()
	if numEntries > 0 then
		local zone
		for id = 1, numEntries do
			local title, level, tag, group, header, collapsed, completed, daily = GetQuestLogTitle(id)
			if header then
				zone = title
				if collapsed then
					collapsedHeader[zone] = true
				elseif collapsedHeader[zone] then
					collapsedHeader[zone] = nil
				end
				if not questsByZone[zone] then
					tomQuest2:addZone(zone)
				end
			else
				local uid = tonumber(match(GetQuestLink(id), 'quest:(%d+)'))
				questsIdToUid[id] = uid
				questsTitleToUid[title] = uid
				if not quests[uid] or (quests[uid] and not quests[uid].complete[playerName]) then
					local numObjectives = quests[uid] and quests[uid].numObjectives or GetNumQuestLeaderBoards(id)
					tomQuest2:addQuest(playerName, firstRun, uid, title, level or 0, tag or "", group or 0, daily or 0, numObjectives or 0, completed or 0, zone, id)
					quests[uid].id = id
				else
					quests[uid].id = id
					if quests[uid].complete[playerName] ~= completed then
						if completed == 1 then
							tomQuest2:questComplete(playerName, firstRun, uid)
							tomQuest2.numCompletedQuests = tomQuest2.numCompletedQuests + 1
						elseif completed == -1 then
							tomQuest2:questFailed(playerName, firstRun, uid)
						elseif quests[uid].complete[playerName] == 1 then
							tomQuest2:questUnComplete(playerName, firstRun, uid)
							tomQuest2.numCompletedQuests = tomQuest2.numCompletedQuests - 1
						end
					elseif completed == 1 then
						tomQuest2.numCompletedQuests = tomQuest2.numCompletedQuests + 1
					end
				end
				local started = 0
				local numObjectivesOK = 0
				if quests[uid].numObjectives > 0 then
					for objective = 1, quests[uid].numObjectives do
						local need, got, nNeed, nGot, desc
						local description, qType, done = GetQuestLogLeaderBoard(objective, id)
						local unknownQT = false
						if qType == "item" or qType == "object" then
							qType = "object"
							desc, got, need = description:match(objectsPattern)
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "player" then
							local faction = UnitFactionGroup("player")
							if faction == "Alliance" then
								desc = LC["Alliance player killed"]
							else
								desc = LC["Horde player killed"]
							end
							got, need = description:match(playersPattern)
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "monster" then
							desc, got, need = description:match(monstersPattern)
							if desc == nil or got == nil or need == nil then
								desc, got, need = description:match(objectsPattern)
							end
							nNeed, nGot = tonumber(need), tonumber(got)
						elseif qType == "reputation" then
							desc, got, need = description:match(factionPattern)
							nNeed, nGot = reactions[need], reactions[got]
						elseif qType == "event" then
							 desc = description
							 got = done and 1 or 0
							 need = 1
							 nNeed, nGot = need, got
						else
							tomQuest2:Print("Quest objective type unknown please report to Gagou on the WowAce, WowInterface or in game on the EU Drek'Thar Server")
							tomQuest2:Print(qType)
							tomQuest2:Print(description)
							unknownQT = true
						end
						if not desc or strtrim(desc) == "" then
							questLogNeedUpdate = true
							questLogUpdatePending = true
						elseif not unknownQT then
							numObjectivesOK = numObjectivesOK + 1
							if not questsObjectives[uid][objective] or not questsObjectives[uid][objective].got[playerName] then
								tomQuest2:addQuestObjective(playerName, firstRun, uid, objective, desc, qType, got, need, nGot, nNeed)
								if nGot ~= 0 then
									started = 1
								end
							elseif questsObjectives[uid][objective].got[playerName] then
								local _, oldNGot = questsObjectives[uid][objective].got[playerName]:match("^(.-)~(%d-)$")
								oldNGot = tonumber(oldNGot)
								if oldNGot ~= nGot then
									tomQuest2:questObjectiveProgress(playerName, firstRun, uid, objective, got, nGot)
								end
							end
						end
					end
				end
				quests[uid].timeStamp = timeStamp
				if quests[uid].numObjectives == numObjectivesOK then
					addQuestDetails(uid)
					if not quests[uid].sync then
						quests[uid].sync = true
						tomQuest2.cbh:Fire("endPlayerQuest", firstRun, "r", uid, started)
					end
				end
			end
		end
	end
	if GetQuestLogSelection() ~= selectionId then
		SelectQuestLogEntry(selectionId)
	end
	if not firstRun then
		if questLogNeedUpdate then
			tomQuest2:ScheduleTimer("QUEST_LOG_UPDATE", 0.1, "FORCED")
		end
		for uid, qData in pairs(quests) do
			if qData.complete[playerName] and qData.timeStamp ~= timeStamp and not collapsedHeader[qData.zone] then
				tomQuest2:questLost(playerName, false, uid, abandoning, 0)
			elseif qData.complete[playerName] and qData.timeStamp ~= timeStamp and collapsedHeader[qData.zone] then
				quests[uid].id = nil
			end
		end
	else
		if questLogNeedUpdate then
			tomQuest2:ScheduleTimer("QUEST_LOG_UPDATE", 0.1, "FORCED")
		else
			tomQuest2.cbh:Fire("initQuestsTracker")
			tomQuest2.cbh:Fire("initParty")
			firstRun = false
			tomQuest2:updateBag()
			self:RegisterBucketEvent("BAG_UPDATE", 1, "updateBag")
		end
	end
	tomQuest2.cbh:Fire("questLogUpdated", true, true)
	abandoning = nil
end

-----------------------
--- PLAYER_LEVEL_UP ---
-----------------------
function tomQuest2:PLAYER_LEVEL_UP(event, newPlayerLevel)
	playerLevel = newPlayerLevel
	for zone, zData in pairs(zones) do
		if zData.minLevel ~= 0 then
			local r, g, b = LibTourist:GetLevelColor(zone)
			zones[zone].color = format("%02x%02x%02x", r*255, g*255, b*255)
		end
	end
	for uid, qData in pairs(quests) do
		local qc = getDifficultyColor(qData.level - playerLevel)
		quests[uid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	end
	tomQuest2.cbh:Fire("questLogUpdated", false, true)
	questsSort()
end

------------------
--- BAG_UPDATE ---
------------------
local function searchInTooltip(item, pattern)
	if item then
		scanTooltipTQ2:ClearLines()
		scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
		scanTooltipTQ2:SetHyperlink(item)
		scanTooltipTQ2:Show()
		for i= 2, 4 do
			local text = _G["scanTooltipTQ2TextLeft"..i]:GetText() or ""
			if text == pattern then
				scanTooltipTQ2:Hide()
				return true
			end
		end
		scanTooltipTQ2:Hide()
	end
	return false
end

local function analyseItem(item, batch)
	if not items[item] then
		local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(item)
		local color = rarityColor[itemRarity]
		local itemSpell = GetItemSpell(item)
		if itemType == LC["Quest"] then
			if itemSpell or searchInTooltip(item, ITEM_SPELL_TRIGGER_ONUSE) then
				for uid, qData in pairs (quests) do
					if qData.complete[playerName] and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
						items[item] = uid
						quests[uid].specialItemLink, quests[uid].specialItemIcon = item, itemTexture
						return true
					end
				end
				items[item] = -1
				usableQuestItems[item] = new()
				usableQuestItems[item].icon, usableQuestItems[item].color, usableQuestItems[item].name = itemTexture, color, itemName
				numUsableQuestItems = numUsableQuestItems + 1
				return true
			elseif searchInTooltip(item, ITEM_STARTS_QUEST) then
				items[item] = 0
				itemStartingQuest[item] = new()
				itemStartingQuest[item].icon, itemStartingQuest[item].color, itemStartingQuest[item].name = itemTexture, color, itemName
				numItemsStartingQuest = numItemsStartingQuest + 1
				tomQuest2.cbh:Fire("itemStartingQuestLooted", item, batch)
				return true
			end
		elseif searchInTooltip(item, ITEM_STARTS_QUEST) then
			items[item] = 0
			itemStartingQuest[item] = new()
			itemStartingQuest[item].icon, itemStartingQuest[item].color, itemStartingQuest[item].name = itemTexture, color, itemName
			numItemsStartingQuest = numItemsStartingQuest + 1
			tomQuest2.cbh:Fire("itemStartingQuestLooted", item, batch)
			return true
		else
			items[item] = -2
			return false
		end
	elseif items[item] == -1 then
		local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(item)
		for uid, qData in pairs (quests) do
			if qData.complete[playerName] and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
				items[item] = uid
				quests[uid].specialItemLink, quests[uid].specialItemIcon = item, itemTexture
				numUsableQuestItems = numUsableQuestItems - 1
				usableQuestItems[item] = del(usableQuestItems[item])
				return true
			end
		end
	else
		return false
	end
end

function tomQuest2:updateBag(bagChanged)
	local timeStamp = GetTime()
	local updateQuestsTracker = nil
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local item = GetContainerItemLink(bag, slot)
			if item then
				itemsTimeStamp[item] = timeStamp
				local update = analyseItem(item, true)
				if update then updateQuestsTracker = true end
			end
		end
	end
	for slotId in pairs(inventorySlotId) do
		local item = GetInventoryItemLink("player", slotId)
		if item then
			itemsTimeStamp[item] = timeStamp
			local update = analyseItem(item, false)
			if update then updateQuestsTracker = true end
		end
	end
	for item in pairs(itemsTimeStamp) do
		if itemsTimeStamp[item] ~= timeStamp then
			itemsTimeStamp[item] = nil
			if items[item] then
				if items[item] == 0 then
					itemStartingQuest[item] = del(itemStartingQuest[item])
					numItemsStartingQuest = numItemsStartingQuest - 1
					updateQuestsTracker = true
					items[item] = nil
				elseif items[item] == -1 then
					usableQuestItems[item] = del(usableQuestItems[item])
					numUsableQuestItems = numUsableQuestItems - 1
					updateQuestsTracker = true
					items[item] = nil
				elseif items[item] == -2 then
					items[item] = nil
				end
			end
			if currentItemMacro == item then
				tomQuest2:generateSpecialItemMacro()
			end
		end
	end
	if updateQuestsTracker then
		tomQuest2.cbh:Fire("updateQuestsTracker")
	end
end

----------------
--- inCombat ---
----------------
function tomQuest2:inCombat()
	if UnitAffectingCombat("player") then
		tomQuest2.cbh:Fire("inCombat")
	else
		tomQuest2.cbh:Fire("outOfCombat")
	end
end

--------------------------------
--- displayQuestInformations ---
--------------------------------
function tomQuest2:displayQuestInformations(uid)
	if prdb.modules["informations"] then
		tomQuest2.cbh:Fire("displayQuestInformations", uid)
	elseif not prdb.modules["informations"] and quests[uid] and quests[uid].id then
		if QuestLogFrame:IsVisible() then
			if GetQuestLogSelection() == quests[uid].id then
				return HideUIPanel(QuestLogFrame)
			end
		else
			ShowUIPanel(QuestLogFrame)
		end
		if (numEntries > QUESTS_DISPLAYED) then
			if (quests[uid].id <= numEntries - QUESTS_DISPLAYED) then
				FauxScrollFrame_SetOffset(QuestLogListScrollFrame, quests[uid].id - 1)
				QuestLogListScrollFrameScrollBar:SetValue((quests[uid].id - 1) * QUESTLOG_QUEST_HEIGHT)
			else
				FauxScrollFrame_SetOffset(QuestLogListScrollFrame, numEntries - QUESTS_DISPLAYED)
				QuestLogListScrollFrameScrollBar:SetValue((numEntries - QUESTS_DISPLAYED) * QUESTLOG_QUEST_HEIGHT)
			end
		end
		SelectQuestLogEntry(quests[uid].id)
		QuestLog_SetSelection(quests[uid].id)
		_G["QuestLogTitle"..(quests[uid].id - FauxScrollFrame_GetOffset(QuestLogListScrollFrame))]:Click()
	end
end

------------------------
--- Macro Generation ---
------------------------
function tomQuest2:generateSpecialItemMacro(uid, item)
	if uid and quests[uid].id and quests[uid].specialItemLink then
		currentUidMacro = uid
		currentItemMacro = nil
		if InCombatLockdown() then return end
		local found, _, itemString = find(quests[uid].specialItemLink, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	elseif item and items[item] then
		currentUidMacro = nil
		currentItemMacro = item
		if InCombatLockdown() then return end
		local found, _, itemString = find(item, "^|c%x+|H(.+)|h%[.*%]")
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "#showtooltip\n/use "..itemString, 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "#showtooltip\n/use "..itemString)
		end
	elseif not uid and not item then
		currentUidMacro = nil
		currentItemMacro = nil
		local index = GetMacroIndexByName("tomQuest2_SI")
		if index == 0 then
			index = CreateMacro("tomQuest2_SI", 1, "", 0)
			PickupMacro(index)
		else
			EditMacro(index, "tomQuest2_SI", 1, "")
		end
	end
end

---------------------
--- toggle Module ---
---------------------
function tomQuest2:toggleAnnounce()
	if tomQuest2:getModuleEnabled("announce") then
		tomQuest2:setModuleEnabled("announce", false)
		tomQuest2:Print(LC["Announcement module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("announce", true)
		tomQuest2:Print(LC["Announcement module is now Enabled"])
	end
end

function tomQuest2:toggleSyncParty()
	if tomQuest2:getModuleEnabled("syncParty") then
		tomQuest2:setModuleEnabled("syncParty", false)
		tomQuest2:Print(LC["Party synchronization module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("syncParty", true)
		tomQuest2:Print(LC["Party synchronization module is now Enabled"])
	end
end

function tomQuest2:toggleQuestsTracker()
	if tomQuest2:getModuleEnabled("questsTracker") then
		tomQuest2:setModuleEnabled("questsTracker", false)
		tomQuest2:Print(LC["Quests tracking module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("questsTracker", true)
		tomQuest2:Print(LC["Quests tracking module is now Enabled"])
	end
end

function tomQuest2:toggleAchievementTracker()
	if tomQuest2:getModuleEnabled("achievementTracker") then
		tomQuest2:setModuleEnabled("achievementTracker", false)
		tomQuest2:Print(LC["Achievements tracking module is now Disabled"])
	else
		tomQuest2:setModuleEnabled("achievementTracker", true)
		tomQuest2:Print(LC["Achievements tracking module is now Enabled"])
	end
end

--------------------------
--- Keybinding globals ---
--------------------------
BINDING_HEADER_TOMQUEST2 = "tomQuest2"